###############################################################################

require 'logger'

###############################################################################

module TerraformWrapper

###############################################################################

  module Shared

###############################################################################

    class Logger < ::Logger

###############################################################################

      @colour = false

###############################################################################

      def colour()
        @colour
      end

###############################################################################

      def colour=(enabled)
        @colour = [ true, false ].include?(enabled) ? enabled : false
      end

###############################################################################

      def success(message)
        info(format(colour: 32, message: message))
      end

###############################################################################

      def warn(message)
        super(format(colour: 33, message: message))
      end

###############################################################################

      def error(message)
        super(format(colour: 31, message: message))
      end

###############################################################################

      def fatal(message)
        super(format(colour: 31, message: message))
        exit(1)
      end

###############################################################################

      private

###############################################################################

      def format(colour: 32, message:)
        return @colour ? "\e[" + colour.to_s + "m" + message + "\e[0m" : message
      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
