###############################################################################

require 'logger'

###############################################################################

module TerraformWrapper

###############################################################################

  module Shared

###############################################################################

    module Logging

###############################################################################

      private

###############################################################################

      def logger
        @logger ||= Logging.logger_for(self.class.name)
      end

###############################################################################

      @loggers = {}

###############################################################################

      class << self

###############################################################################

        def logger_for(classname)
          @loggers[classname] ||= configure_logger_for(classname)
        end

###############################################################################

        def configure_logger_for(classname)
          colour = ENV["TERRAFORM_WRAPPER_LOG_COLOUR"] || "true"
          level  = ENV["TERRAFORM_WRAPPER_LOG_LEVEL"]  || "INFO"

          logger = ::TerraformWrapper::Shared::Logger.new(STDOUT)

          logger.colour   = colour.downcase == "true"
          logger.level    = level.upcase
          logger.progname = classname

          logger.formatter = proc do |severity, datetime, progname, msg|
            sevId = severity.chars.first.upcase
            "[#{sevId}] [#{progname}] #{msg}\n"
          end

          logger
        end

###############################################################################

      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
