###############################################################################

module TerraformWrapper

###############################################################################

  module Tasks

###############################################################################

    class Validate < ::Rake::TaskLib

###############################################################################

      include TerraformWrapper::Shared::Logging

###############################################################################

      @binary
      @code

###############################################################################

      def initialize(binary:, code:)
        @binary = binary
        @code   = code

        yield self if block_given?

        validate_task
      end

###############################################################################

      def validate_task
        desc "Validates the Terraform code for an infrastructure component."
        task :validate => :binary do |t, args|
          runner = TerraformWrapper::Shared::Runner.new(binary: @binary, code: @code)

          logger.info("Validating Terraform component: #{@code.name}...")

          runner.download
          runner.validate
        end
      end

###############################################################################

    end

###############################################################################

  end

###############################################################################

end

###############################################################################
